%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% @brief: Timer Callback Function %
function CallBack_Timer(obj, event, MyText)
    global S;
    Time = toc;

    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Update according to the disperion relation %
    Hkt = S.H0.*exp(1i.*S.W*Time) + S.Hm.*exp(-1i.*S.W*Time);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Generate HeightField at time t using ifft %
    Ht = abs(ifft2(Hkt));
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%% UPDATE SCALE IF NECESSARY %%%%%%%
    mi = min(Ht(:));
    ma = max(Ht(:));
    UpdateRange = 0;
    if(mi < S.MinHt)
        S.MinHt = mi;
        UpdateRange = 1;
    end
    if(ma > S.MaxHt)
        S.MaxHt = ma;
        UpdateRange = 1;
    end
    if(UpdateRange)
        set(gca,'zlim',[S.MinHt S.MaxHt]);
    end
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Update HeighField with New Data %
    set(S.Ax,'zdata',Ht);

    
end

